pax_global_header 0000666 0000000 0000000 00000000064 12406256740 0014520 g ustar 00root root 0000000 0000000 52 comment=941bd8f171fdbebdc8d70a0cb1a795a18ab9a42d
fadecut-0.1.4/ 0000775 0000000 0000000 00000000000 12406256740 0013135 5 ustar 00root root 0000000 0000000 fadecut-0.1.4/COPYING 0000664 0000000 0000000 00000104513 12406256740 0014174 0 ustar 00root root 0000000 0000000 GNU GENERAL PUBLIC LICENSE
Version 3, 29 June 2007
Copyright (C) 2007 Free Software Foundation, Inc.
Everyone is permitted to copy and distribute verbatim copies
of this license document, but changing it is not allowed.
Preamble
The GNU General Public License is a free, copyleft license for
software and other kinds of works.
The licenses for most software and other practical works are designed
to take away your freedom to share and change the works. By contrast,
the GNU General Public License is intended to guarantee your freedom to
share and change all versions of a program--to make sure it remains free
software for all its users. We, the Free Software Foundation, use the
GNU General Public License for most of our software; it applies also to
any other work released this way by its authors. You can apply it to
your programs, too.
When we speak of free software, we are referring to freedom, not
price. Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
them if you wish), that you receive source code or can get it if you
want it, that you can change the software or use pieces of it in new
free programs, and that you know you can do these things.
To protect your rights, we need to prevent others from denying you
these rights or asking you to surrender the rights. Therefore, you have
certain responsibilities if you distribute copies of the software, or if
you modify it: responsibilities to respect the freedom of others.
For example, if you distribute copies of such a program, whether
gratis or for a fee, you must pass on to the recipients the same
freedoms that you received. You must make sure that they, too, receive
or can get the source code. And you must show them these terms so they
know their rights.
Developers that use the GNU GPL protect your rights with two steps:
(1) assert copyright on the software, and (2) offer you this License
giving you legal permission to copy, distribute and/or modify it.
For the developers' and authors' protection, the GPL clearly explains
that there is no warranty for this free software. For both users' and
authors' sake, the GPL requires that modified versions be marked as
changed, so that their problems will not be attributed erroneously to
authors of previous versions.
Some devices are designed to deny users access to install or run
modified versions of the software inside them, although the manufacturer
can do so. This is fundamentally incompatible with the aim of
protecting users' freedom to change the software. The systematic
pattern of such abuse occurs in the area of products for individuals to
use, which is precisely where it is most unacceptable. Therefore, we
have designed this version of the GPL to prohibit the practice for those
products. If such problems arise substantially in other domains, we
stand ready to extend this provision to those domains in future versions
of the GPL, as needed to protect the freedom of users.
Finally, every program is threatened constantly by software patents.
States should not allow patents to restrict development and use of
software on general-purpose computers, but in those that do, we wish to
avoid the special danger that patents applied to a free program could
make it effectively proprietary. To prevent this, the GPL assures that
patents cannot be used to render the program non-free.
The precise terms and conditions for copying, distribution and
modification follow.
TERMS AND CONDITIONS
0. Definitions.
"This License" refers to version 3 of the GNU General Public License.
"Copyright" also means copyright-like laws that apply to other kinds of
works, such as semiconductor masks.
"The Program" refers to any copyrightable work licensed under this
License. Each licensee is addressed as "you". "Licensees" and
"recipients" may be individuals or organizations.
To "modify" a work means to copy from or adapt all or part of the work
in a fashion requiring copyright permission, other than the making of an
exact copy. The resulting work is called a "modified version" of the
earlier work or a work "based on" the earlier work.
A "covered work" means either the unmodified Program or a work based
on the Program.
To "propagate" a work means to do anything with it that, without
permission, would make you directly or secondarily liable for
infringement under applicable copyright law, except executing it on a
computer or modifying a private copy. Propagation includes copying,
distribution (with or without modification), making available to the
public, and in some countries other activities as well.
To "convey" a work means any kind of propagation that enables other
parties to make or receive copies. Mere interaction with a user through
a computer network, with no transfer of a copy, is not conveying.
An interactive user interface displays "Appropriate Legal Notices"
to the extent that it includes a convenient and prominently visible
feature that (1) displays an appropriate copyright notice, and (2)
tells the user that there is no warranty for the work (except to the
extent that warranties are provided), that licensees may convey the
work under this License, and how to view a copy of this License. If
the interface presents a list of user commands or options, such as a
menu, a prominent item in the list meets this criterion.
1. Source Code.
The "source code" for a work means the preferred form of the work
for making modifications to it. "Object code" means any non-source
form of a work.
A "Standard Interface" means an interface that either is an official
standard defined by a recognized standards body, or, in the case of
interfaces specified for a particular programming language, one that
is widely used among developers working in that language.
The "System Libraries" of an executable work include anything, other
than the work as a whole, that (a) is included in the normal form of
packaging a Major Component, but which is not part of that Major
Component, and (b) serves only to enable use of the work with that
Major Component, or to implement a Standard Interface for which an
implementation is available to the public in source code form. A
"Major Component", in this context, means a major essential component
(kernel, window system, and so on) of the specific operating system
(if any) on which the executable work runs, or a compiler used to
produce the work, or an object code interpreter used to run it.
The "Corresponding Source" for a work in object code form means all
the source code needed to generate, install, and (for an executable
work) run the object code and to modify the work, including scripts to
control those activities. However, it does not include the work's
System Libraries, or general-purpose tools or generally available free
programs which are used unmodified in performing those activities but
which are not part of the work. For example, Corresponding Source
includes interface definition files associated with source files for
the work, and the source code for shared libraries and dynamically
linked subprograms that the work is specifically designed to require,
such as by intimate data communication or control flow between those
subprograms and other parts of the work.
The Corresponding Source need not include anything that users
can regenerate automatically from other parts of the Corresponding
Source.
The Corresponding Source for a work in source code form is that
same work.
2. Basic Permissions.
All rights granted under this License are granted for the term of
copyright on the Program, and are irrevocable provided the stated
conditions are met. This License explicitly affirms your unlimited
permission to run the unmodified Program. The output from running a
covered work is covered by this License only if the output, given its
content, constitutes a covered work. This License acknowledges your
rights of fair use or other equivalent, as provided by copyright law.
You may make, run and propagate covered works that you do not
convey, without conditions so long as your license otherwise remains
in force. You may convey covered works to others for the sole purpose
of having them make modifications exclusively for you, or provide you
with facilities for running those works, provided that you comply with
the terms of this License in conveying all material for which you do
not control copyright. Those thus making or running the covered works
for you must do so exclusively on your behalf, under your direction
and control, on terms that prohibit them from making any copies of
your copyrighted material outside their relationship with you.
Conveying under any other circumstances is permitted solely under
the conditions stated below. Sublicensing is not allowed; section 10
makes it unnecessary.
3. Protecting Users' Legal Rights From Anti-Circumvention Law.
No covered work shall be deemed part of an effective technological
measure under any applicable law fulfilling obligations under article
11 of the WIPO copyright treaty adopted on 20 December 1996, or
similar laws prohibiting or restricting circumvention of such
measures.
When you convey a covered work, you waive any legal power to forbid
circumvention of technological measures to the extent such circumvention
is effected by exercising rights under this License with respect to
the covered work, and you disclaim any intention to limit operation or
modification of the work as a means of enforcing, against the work's
users, your or third parties' legal rights to forbid circumvention of
technological measures.
4. Conveying Verbatim Copies.
You may convey verbatim copies of the Program's source code as you
receive it, in any medium, provided that you conspicuously and
appropriately publish on each copy an appropriate copyright notice;
keep intact all notices stating that this License and any
non-permissive terms added in accord with section 7 apply to the code;
keep intact all notices of the absence of any warranty; and give all
recipients a copy of this License along with the Program.
You may charge any price or no price for each copy that you convey,
and you may offer support or warranty protection for a fee.
5. Conveying Modified Source Versions.
You may convey a work based on the Program, or the modifications to
produce it from the Program, in the form of source code under the
terms of section 4, provided that you also meet all of these conditions:
a) The work must carry prominent notices stating that you modified
it, and giving a relevant date.
b) The work must carry prominent notices stating that it is
released under this License and any conditions added under section
7. This requirement modifies the requirement in section 4 to
"keep intact all notices".
c) You must license the entire work, as a whole, under this
License to anyone who comes into possession of a copy. This
License will therefore apply, along with any applicable section 7
additional terms, to the whole of the work, and all its parts,
regardless of how they are packaged. This License gives no
permission to license the work in any other way, but it does not
invalidate such permission if you have separately received it.
d) If the work has interactive user interfaces, each must display
Appropriate Legal Notices; however, if the Program has interactive
interfaces that do not display Appropriate Legal Notices, your
work need not make them do so.
A compilation of a covered work with other separate and independent
works, which are not by their nature extensions of the covered work,
and which are not combined with it such as to form a larger program,
in or on a volume of a storage or distribution medium, is called an
"aggregate" if the compilation and its resulting copyright are not
used to limit the access or legal rights of the compilation's users
beyond what the individual works permit. Inclusion of a covered work
in an aggregate does not cause this License to apply to the other
parts of the aggregate.
6. Conveying Non-Source Forms.
You may convey a covered work in object code form under the terms
of sections 4 and 5, provided that you also convey the
machine-readable Corresponding Source under the terms of this License,
in one of these ways:
a) Convey the object code in, or embodied in, a physical product
(including a physical distribution medium), accompanied by the
Corresponding Source fixed on a durable physical medium
customarily used for software interchange.
b) Convey the object code in, or embodied in, a physical product
(including a physical distribution medium), accompanied by a
written offer, valid for at least three years and valid for as
long as you offer spare parts or customer support for that product
model, to give anyone who possesses the object code either (1) a
copy of the Corresponding Source for all the software in the
product that is covered by this License, on a durable physical
medium customarily used for software interchange, for a price no
more than your reasonable cost of physically performing this
conveying of source, or (2) access to copy the
Corresponding Source from a network server at no charge.
c) Convey individual copies of the object code with a copy of the
written offer to provide the Corresponding Source. This
alternative is allowed only occasionally and noncommercially, and
only if you received the object code with such an offer, in accord
with subsection 6b.
d) Convey the object code by offering access from a designated
place (gratis or for a charge), and offer equivalent access to the
Corresponding Source in the same way through the same place at no
further charge. You need not require recipients to copy the
Corresponding Source along with the object code. If the place to
copy the object code is a network server, the Corresponding Source
may be on a different server (operated by you or a third party)
that supports equivalent copying facilities, provided you maintain
clear directions next to the object code saying where to find the
Corresponding Source. Regardless of what server hosts the
Corresponding Source, you remain obligated to ensure that it is
available for as long as needed to satisfy these requirements.
e) Convey the object code using peer-to-peer transmission, provided
you inform other peers where the object code and Corresponding
Source of the work are being offered to the general public at no
charge under subsection 6d.
A separable portion of the object code, whose source code is excluded
from the Corresponding Source as a System Library, need not be
included in conveying the object code work.
A "User Product" is either (1) a "consumer product", which means any
tangible personal property which is normally used for personal, family,
or household purposes, or (2) anything designed or sold for incorporation
into a dwelling. In determining whether a product is a consumer product,
doubtful cases shall be resolved in favor of coverage. For a particular
product received by a particular user, "normally used" refers to a
typical or common use of that class of product, regardless of the status
of the particular user or of the way in which the particular user
actually uses, or expects or is expected to use, the product. A product
is a consumer product regardless of whether the product has substantial
commercial, industrial or non-consumer uses, unless such uses represent
the only significant mode of use of the product.
"Installation Information" for a User Product means any methods,
procedures, authorization keys, or other information required to install
and execute modified versions of a covered work in that User Product from
a modified version of its Corresponding Source. The information must
suffice to ensure that the continued functioning of the modified object
code is in no case prevented or interfered with solely because
modification has been made.
If you convey an object code work under this section in, or with, or
specifically for use in, a User Product, and the conveying occurs as
part of a transaction in which the right of possession and use of the
User Product is transferred to the recipient in perpetuity or for a
fixed term (regardless of how the transaction is characterized), the
Corresponding Source conveyed under this section must be accompanied
by the Installation Information. But this requirement does not apply
if neither you nor any third party retains the ability to install
modified object code on the User Product (for example, the work has
been installed in ROM).
The requirement to provide Installation Information does not include a
requirement to continue to provide support service, warranty, or updates
for a work that has been modified or installed by the recipient, or for
the User Product in which it has been modified or installed. Access to a
network may be denied when the modification itself materially and
adversely affects the operation of the network or violates the rules and
protocols for communication across the network.
Corresponding Source conveyed, and Installation Information provided,
in accord with this section must be in a format that is publicly
documented (and with an implementation available to the public in
source code form), and must require no special password or key for
unpacking, reading or copying.
7. Additional Terms.
"Additional permissions" are terms that supplement the terms of this
License by making exceptions from one or more of its conditions.
Additional permissions that are applicable to the entire Program shall
be treated as though they were included in this License, to the extent
that they are valid under applicable law. If additional permissions
apply only to part of the Program, that part may be used separately
under those permissions, but the entire Program remains governed by
this License without regard to the additional permissions.
When you convey a copy of a covered work, you may at your option
remove any additional permissions from that copy, or from any part of
it. (Additional permissions may be written to require their own
removal in certain cases when you modify the work.) You may place
additional permissions on material, added by you to a covered work,
for which you have or can give appropriate copyright permission.
Notwithstanding any other provision of this License, for material you
add to a covered work, you may (if authorized by the copyright holders of
that material) supplement the terms of this License with terms:
a) Disclaiming warranty or limiting liability differently from the
terms of sections 15 and 16 of this License; or
b) Requiring preservation of specified reasonable legal notices or
author attributions in that material or in the Appropriate Legal
Notices displayed by works containing it; or
c) Prohibiting misrepresentation of the origin of that material, or
requiring that modified versions of such material be marked in
reasonable ways as different from the original version; or
d) Limiting the use for publicity purposes of names of licensors or
authors of the material; or
e) Declining to grant rights under trademark law for use of some
trade names, trademarks, or service marks; or
f) Requiring indemnification of licensors and authors of that
material by anyone who conveys the material (or modified versions of
it) with contractual assumptions of liability to the recipient, for
any liability that these contractual assumptions directly impose on
those licensors and authors.
All other non-permissive additional terms are considered "further
restrictions" within the meaning of section 10. If the Program as you
received it, or any part of it, contains a notice stating that it is
governed by this License along with a term that is a further
restriction, you may remove that term. If a license document contains
a further restriction but permits relicensing or conveying under this
License, you may add to a covered work material governed by the terms
of that license document, provided that the further restriction does
not survive such relicensing or conveying.
If you add terms to a covered work in accord with this section, you
must place, in the relevant source files, a statement of the
additional terms that apply to those files, or a notice indicating
where to find the applicable terms.
Additional terms, permissive or non-permissive, may be stated in the
form of a separately written license, or stated as exceptions;
the above requirements apply either way.
8. Termination.
You may not propagate or modify a covered work except as expressly
provided under this License. Any attempt otherwise to propagate or
modify it is void, and will automatically terminate your rights under
this License (including any patent licenses granted under the third
paragraph of section 11).
However, if you cease all violation of this License, then your
license from a particular copyright holder is reinstated (a)
provisionally, unless and until the copyright holder explicitly and
finally terminates your license, and (b) permanently, if the copyright
holder fails to notify you of the violation by some reasonable means
prior to 60 days after the cessation.
Moreover, your license from a particular copyright holder is
reinstated permanently if the copyright holder notifies you of the
violation by some reasonable means, this is the first time you have
received notice of violation of this License (for any work) from that
copyright holder, and you cure the violation prior to 30 days after
your receipt of the notice.
Termination of your rights under this section does not terminate the
licenses of parties who have received copies or rights from you under
this License. If your rights have been terminated and not permanently
reinstated, you do not qualify to receive new licenses for the same
material under section 10.
9. Acceptance Not Required for Having Copies.
You are not required to accept this License in order to receive or
run a copy of the Program. Ancillary propagation of a covered work
occurring solely as a consequence of using peer-to-peer transmission
to receive a copy likewise does not require acceptance. However,
nothing other than this License grants you permission to propagate or
modify any covered work. These actions infringe copyright if you do
not accept this License. Therefore, by modifying or propagating a
covered work, you indicate your acceptance of this License to do so.
10. Automatic Licensing of Downstream Recipients.
Each time you convey a covered work, the recipient automatically
receives a license from the original licensors, to run, modify and
propagate that work, subject to this License. You are not responsible
for enforcing compliance by third parties with this License.
An "entity transaction" is a transaction transferring control of an
organization, or substantially all assets of one, or subdividing an
organization, or merging organizations. If propagation of a covered
work results from an entity transaction, each party to that
transaction who receives a copy of the work also receives whatever
licenses to the work the party's predecessor in interest had or could
give under the previous paragraph, plus a right to possession of the
Corresponding Source of the work from the predecessor in interest, if
the predecessor has it or can get it with reasonable efforts.
You may not impose any further restrictions on the exercise of the
rights granted or affirmed under this License. For example, you may
not impose a license fee, royalty, or other charge for exercise of
rights granted under this License, and you may not initiate litigation
(including a cross-claim or counterclaim in a lawsuit) alleging that
any patent claim is infringed by making, using, selling, offering for
sale, or importing the Program or any portion of it.
11. Patents.
A "contributor" is a copyright holder who authorizes use under this
License of the Program or a work on which the Program is based. The
work thus licensed is called the contributor's "contributor version".
A contributor's "essential patent claims" are all patent claims
owned or controlled by the contributor, whether already acquired or
hereafter acquired, that would be infringed by some manner, permitted
by this License, of making, using, or selling its contributor version,
but do not include claims that would be infringed only as a
consequence of further modification of the contributor version. For
purposes of this definition, "control" includes the right to grant
patent sublicenses in a manner consistent with the requirements of
this License.
Each contributor grants you a non-exclusive, worldwide, royalty-free
patent license under the contributor's essential patent claims, to
make, use, sell, offer for sale, import and otherwise run, modify and
propagate the contents of its contributor version.
In the following three paragraphs, a "patent license" is any express
agreement or commitment, however denominated, not to enforce a patent
(such as an express permission to practice a patent or covenant not to
sue for patent infringement). To "grant" such a patent license to a
party means to make such an agreement or commitment not to enforce a
patent against the party.
If you convey a covered work, knowingly relying on a patent license,
and the Corresponding Source of the work is not available for anyone
to copy, free of charge and under the terms of this License, through a
publicly available network server or other readily accessible means,
then you must either (1) cause the Corresponding Source to be so
available, or (2) arrange to deprive yourself of the benefit of the
patent license for this particular work, or (3) arrange, in a manner
consistent with the requirements of this License, to extend the patent
license to downstream recipients. "Knowingly relying" means you have
actual knowledge that, but for the patent license, your conveying the
covered work in a country, or your recipient's use of the covered work
in a country, would infringe one or more identifiable patents in that
country that you have reason to believe are valid.
If, pursuant to or in connection with a single transaction or
arrangement, you convey, or propagate by procuring conveyance of, a
covered work, and grant a patent license to some of the parties
receiving the covered work authorizing them to use, propagate, modify
or convey a specific copy of the covered work, then the patent license
you grant is automatically extended to all recipients of the covered
work and works based on it.
A patent license is "discriminatory" if it does not include within
the scope of its coverage, prohibits the exercise of, or is
conditioned on the non-exercise of one or more of the rights that are
specifically granted under this License. You may not convey a covered
work if you are a party to an arrangement with a third party that is
in the business of distributing software, under which you make payment
to the third party based on the extent of your activity of conveying
the work, and under which the third party grants, to any of the
parties who would receive the covered work from you, a discriminatory
patent license (a) in connection with copies of the covered work
conveyed by you (or copies made from those copies), or (b) primarily
for and in connection with specific products or compilations that
contain the covered work, unless you entered into that arrangement,
or that patent license was granted, prior to 28 March 2007.
Nothing in this License shall be construed as excluding or limiting
any implied license or other defenses to infringement that may
otherwise be available to you under applicable patent law.
12. No Surrender of Others' Freedom.
If conditions are imposed on you (whether by court order, agreement or
otherwise) that contradict the conditions of this License, they do not
excuse you from the conditions of this License. If you cannot convey a
covered work so as to satisfy simultaneously your obligations under this
License and any other pertinent obligations, then as a consequence you may
not convey it at all. For example, if you agree to terms that obligate you
to collect a royalty for further conveying from those to whom you convey
the Program, the only way you could satisfy both those terms and this
License would be to refrain entirely from conveying the Program.
13. Use with the GNU Affero General Public License.
Notwithstanding any other provision of this License, you have
permission to link or combine any covered work with a work licensed
under version 3 of the GNU Affero General Public License into a single
combined work, and to convey the resulting work. The terms of this
License will continue to apply to the part which is the covered work,
but the special requirements of the GNU Affero General Public License,
section 13, concerning interaction through a network will apply to the
combination as such.
14. Revised Versions of this License.
The Free Software Foundation may publish revised and/or new versions of
the GNU General Public License from time to time. Such new versions will
be similar in spirit to the present version, but may differ in detail to
address new problems or concerns.
Each version is given a distinguishing version number. If the
Program specifies that a certain numbered version of the GNU General
Public License "or any later version" applies to it, you have the
option of following the terms and conditions either of that numbered
version or of any later version published by the Free Software
Foundation. If the Program does not specify a version number of the
GNU General Public License, you may choose any version ever published
by the Free Software Foundation.
If the Program specifies that a proxy can decide which future
versions of the GNU General Public License can be used, that proxy's
public statement of acceptance of a version permanently authorizes you
to choose that version for the Program.
Later license versions may give you additional or different
permissions. However, no additional obligations are imposed on any
author or copyright holder as a result of your choosing to follow a
later version.
15. Disclaimer of Warranty.
THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
16. Limitation of Liability.
IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGES.
17. Interpretation of Sections 15 and 16.
If the disclaimer of warranty and limitation of liability provided
above cannot be given local legal effect according to their terms,
reviewing courts shall apply local law that most closely approximates
an absolute waiver of all civil liability in connection with the
Program, unless a warranty or assumption of liability accompanies a
copy of the Program in return for a fee.
END OF TERMS AND CONDITIONS
How to Apply These Terms to Your New Programs
If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these terms.
To do so, attach the following notices to the program. It is safest
to attach them to the start of each source file to most effectively
state the exclusion of warranty; and each file should have at least
the "copyright" line and a pointer to where the full notice is found.
Copyright (C)
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see .
Also add information on how to contact you by electronic and paper mail.
If the program does terminal interaction, make it output a short
notice like this when it starts in an interactive mode:
Copyright (C)
This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
This is free software, and you are welcome to redistribute it
under certain conditions; type `show c' for details.
The hypothetical commands `show w' and `show c' should show the appropriate
parts of the General Public License. Of course, your program's commands
might be different; for a GUI interface, you would use an "about box".
You should also get your employer (if you work as a programmer) or school,
if any, to sign a "copyright disclaimer" for the program, if necessary.
For more information on this, and how to apply and follow the GNU GPL, see
.
The GNU General Public License does not permit incorporating your program
into proprietary programs. If your program is a subroutine library, you
may consider it more useful to permit linking proprietary applications with
the library. If this is what you want to do, use the GNU Lesser General
Public License instead of this License. But first, please read
.
fadecut-0.1.4/ChangeLog 0000664 0000000 0000000 00000002304 12406256740 0014706 0 ustar 00root root 0000000 0000000 fadecut 0.1.4
-------------
* Merged pull request from https://github.com/TobleMiner
Added custom editor selection. Script now considers $EDITOR environment
variable first, before choosing vi/vim
fadecut 0.1.3
-------------
* Fixed github.com issue #2 "add custom USER_AGENT" Thanks to
https://github.com/mitsukarenai
fadecut 0.1.2
-------------
* Fixed github.com issue #1 "pidof streamripper problem"
fadecut 0.1.1
-------------
* Exeption handling (Closes debian bug: #645392)
fadecut 0.1.0
-------------
* ripping option -s changed to -r
* write log to ~/.fadecut/statslog.csv for statistics
* autoconverting tags from id3v1 to id3v2
* double files are now 0 byte size
* removed mp3info, now using sox to get information about audio file
* removed mp3splt, now using sox to split audio files
* improve shutdown behaviour. All exit codes and logging messages justified.
* added silence cutting. no more long silence at beginning and end of files.
* Testframework, first tests added
fadecut 0.0.2
-------------
* removed repetition of unnessesary logging
* libsox-fmt-mp3 is needed on debian/ubuntu
* removed -m method
fadecut 0.0.1
-------------
* initial release
fadecut-0.1.4/Makefile 0000664 0000000 0000000 00000001415 12406256740 0014576 0 ustar 00root root 0000000 0000000 #!/usr/bin/make -f
#
# This file is part of fadecut
# https://github.com/micressor/fadecut
#
# fadecut is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fadecut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with fadecut. If not, see .
test:
cd testing && ./fctest
clean:
cd testing && ./cleanup.sh
fadecut-0.1.4/NOTES 0000664 0000000 0000000 00000007165 12406256740 0013761 0 ustar 00root root 0000000 0000000 This file is part of fadecut
https://github.com/micressor/fadecut
fadecut is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
fadecut is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with fadecut. If not, see .
# --- useful info ---------------------------------------------------------------
to change tags you may use lltag (writes only id3v1 tags):
lltag --yes -g SwissPop -c "Radio Swiss Pop" *.mp3
to change filenames according to tags:
lltag --rename "%a_-_%t" --rename-min --rename-sep _ --yes *.mp3
to change filenames with iso-8859 umlaut to utf8:
convmv -f iso-8859-15 -t utf8 -r *.mp3 --notest
another command line tagging tool, which reads and writes also id3v2:
(and it is able to write lyrics and pictures into the files)
(not useful for reading tags)
* eyeD3 - displays and manipulates id3-tags on mp3 files
# --- notes --------------------------------------------------------------------
Coding Style Guide
we are following the coding styles of
. the GNU Coding Standards
http://www.gnu.org/prep/standards/html_node/index.html
. the Bash Reference Manual
http://www.gnu.org/software/bash/manual/bashref.html
. Advanced Bash Scripting Guide
http://tldp.org/LDP/abs/html/index.html
. Bash Style Guide and Coding Standards
[german] http://www3.fh-swf.de/fbin/mehner/download/StyleGuideShell.pdf
[english] http://lug.fh-swf.de/vim/vim-bash/StyleGuideShell.en.pdf
. A Guide to Unix Shell Quoting
http://www.mpi-inf.mpg.de/~uwe/lehre/unixffb/quoting-guide.html
Testframework
* list of testfiles needed:
[done] cut correct - end 01.mp3
[done] cut correct - begin 01.mp3
[done] cut correct - begin and end 01.mp3
[done] error - no tag artist.mp3
[done] error - no tag title.mp3
[done] error - no mp3 file.mp3
* Tests:
outputfiles (cut correct*.*) correct (check binary, length, size, tags)
error handling when bad input files (error*.mp3)
ID3
http://www.id3.org/Introduction
ID3 tags were designed with the MP3 file format in mind. ID3v2 tags
will break formats which are container-based such as Ogg Vorbis and WMA.
Vorbis I specification
http://www.xiph.org/vorbis/doc/Vorbis_I_spec.html#x1-810005
VorbisComment
http://wiki.xiph.org/VorbisComment
is a base-level Metadata format initially created for use with Ogg Vorbis.
It has since been adopted in the specifications of Ogg encapsulations for
other Xiph.Org codecs including Theora, Speex and FLAC.
A very cute reference sound:
http://www.xiph.org/vorbis/listen.html (not reachable)
http://replay.waybackmachine.org/20090628120921/http://www.xiph.org/vorbis/listen.html
http://replay.waybackmachine.org/20081004221732/http://www.xiph.org/vorbis/listen/41_30secOgg-b64M.wav
fadecut-0.1.4/README 0000664 0000000 0000000 00000007761 12406256740 0014030 0 ustar 00root root 0000000 0000000 This file is part of fadecut
https://github.com/micressor/fadecut
fadecut is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
fadecut is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with fadecut. If not, see .
--- Overview -------------------------------------------------------------------
synopsis/short description:
---------------------------
toolset to rip audiostreams, cut, fade in/out and tag the resulting audiofiles
long description (english):
---------------------------
fadecut is a script to rip audio files from a livestream and to process them
automatically. Beginning and ending fo the audio files will be cut and faded
in/out. So logos and advertising of radio stations will be automatically removed.
In streaming mode fadecut is ripping audio files using streamripper. The
downloaded audio files are cutted using silence detection and then faded in and
out. Subsequently, the files are encoded to either ogg or mp3 and tagged with
tags (title, artist, genre and comment provided).
In file mode fadecut is just processing already ripped audio files.
An audio file which has already been processed is detected and will not be
processed again. Not desired songs can be stored in a separate directory. This
files are not processed anymore too.
long description (german):
--------------------------
mit fadecut können Audio Dateien aus einem Livestream gerippt und automatisch
verarbeitet werden. Anfang und Ende der Audiofiles werden geschnitten sowie ein-
und ausgeblendet. Damit können Signete und Werbung von Radiostationen automatisch
entfernt werden.
Im Streaming-Modus startet fadecut den streamripper und lädt damit die Audio
Data herunter. Die heruntergeladenen Audio Dateien werden dann mittels Silence
Detection geschnitten sowie ein- und ausgeblendet. Anschliessend werden die
Dateien wahlweise nach ogg oder mp3 codiert und mit Tags (Titel, Artist, Genre,
Kommentar) versehen.
Ein bereits verarbeiteter Song wird erkannt und nicht neu verarbeitet. Nicht
erwünschte Songs können in einem separaten Verzeichnis abgelegt werden. Diese
werden dann ebenfalls nicht mehr weiter verarbeitet.
--- Requirements ---------------------------------------------------------------
* bash - The GNU Bourne Again SHell
* id3v2 - A command line id3v2 tag editor
* sox - the Swiss army knife of sound processing
* streamripper - download online streams into audio files
* vorbis-tools - several Ogg Vorbis tools
optional, for mp3 encoding:
* lame, An MP3 encoding library (frontend)
--- Ubuntu ---------------------------------------------------------------------
apt-get install bash coreutils findutils nice sed sox libsox-fmt-mp3 streamripper vorbis-tools id3v2
for mp3 encoding:
apt-get install lame
--- Debian ---------------------------------------------------------------------
* lame (mp3 encoding) is official not available in debian.
apt-get vorbis-tools sox libsox-fmt-mp3 streamripper id3v2
--- Building Debian packages from source ---------------------------------------
cd /tmp
git clone https://github.com/micressor/fadecut
cd fadecut
git checkout debian
git archive --format=tar --prefix=fadecut-0.X.X/ 0.X.X | gzip > ../fadecut_0.X.X.orig.tar.gz
dpkg-buildpackage -us -uc
dpkg -i ../fadecut_*.deb
--- Usage ----------------------------------------------------------------------
1. Create a profile file
fadecut -c myradiostation
Edit variables:
STREAM_URL="http://streamurl"
GENRE="Pop"
COMMENT="Radio station comment"
FADE_IN=1
FADE_OUT=4
2. Let's stream, rip and automatically fade & cut now
fadecut -p myradiostation -r
3. man fadecut
fadecut-0.1.4/TODO 0000664 0000000 0000000 00000010070 12406256740 0013623 0 ustar 00root root 0000000 0000000 This file is part of fadecut
https://github.com/micressor/fadecut
fadecut is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
fadecut is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with fadecut. If not, see .
# --- bugs on master branch ----------------------------------------------------
* current no
# --- 0.2.0 release ------------------------------------------------------------
* marco Change ${vars} to $vars
* marco Testframework:
Take testing upstream code directly from git,
add more tests.
Testframework executed by dpkg-buildpackage.
* marco stats, processed songs per hour
* marco logging(): no warning output's, if no -v (verbose) is selected
* marco check license of songs and document if needed in copyrights
here you have:
apt-get install yofrankie
/usr/share/yofrankie-bge/audio
we took:
FrankieDeath.wav
frankie_dielava.wav
frankieloop2.wav
head /usr/share/doc/yofrankie/copyright:
Name: Yo Frankie!
Maintainer: Campbell Barton
Source: http://www.yofrankie.org/
Copyright: 2008, Blender Foundation, www.blender.org
License: GPL-2+
* tinu complete fileprocessing test in testframework
* tinu how to handle case of tags? camel, higher or lowercase?
decide and code it
* tinu how to handle filenames like this:
Gloria Estefan - 1 - 2 - 3.mp3 / gloria_estefan_-_1_-_2_-_3.mp3
PLATINUM - SIGNALS(GAUDINO & ROONEY EDIT).mp3 / platinum_-_signals(gaudino_&_rooney_edit).mp3 (for example put an underscore before paranthesis)
# --- later --------------------------------------------------------------------
* tinu change to getopt(1) to be able to parse --long-options
* tinu add bpm tags (use of debian packet bpm-tools)
* tinu cross correlation with well known ad files
* tinu maybe we could use ffmpeg instead of sox/lame
* tinu wishlist: put a file in $fadecuthome with a list of artist/titles
start fadecut with special option (-w for example) and fadecut
will rip/process only files which are on the wishlist.
this should work with many fadecut processes in parallel, to scan on
many internet-radio stations in parallel to complete the wishlist as
fast as possible
* tinu mp3 normalization / replaygain
* tinu id3 tags umlaut are not correct on N900, wrong characterset
to define who will code this:
* team statistics reporting
* team catch such errors:
streamripper http://club-high.rautemusik.fm/listen.pls
Connecting...
error -6 [SR_ERROR_CANT_RESOLVE_HOSTNAME]
bye..
shutting down
* team find tag on which we write something like 'prcoessed by fadecut vx.y.z'
incl date, version, time, encoder and its version, streamripper and version
* team define constant with version of fadecut
* team lyrics in tags
* team song/album title
* team add support for aacPlus Streams and *.aac files
example: http://www.radioswissjazz.ch/live/aacp.m3u
* team maybe we need to use vbrfix on mp3 files?
* team auto download album art (when more than one: let user select / take newest / take that one with best quality)
* team auto download lyrics
* team auto download guitar tabs
fadecut-0.1.4/examples/ 0000775 0000000 0000000 00000000000 12406256740 0014753 5 ustar 00root root 0000000 0000000 fadecut-0.1.4/examples/80er 0000664 0000000 0000000 00000001576 12406256740 0015465 0 ustar 00root root 0000000 0000000 # This file is part of fadecut
# https://github.com/micressor/fadecut
#
# fadecut is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fadecut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with fadecut. If not, see .
STREAM_URL="http://mp3channels.webradio.antenne.de/80er-kulthits"
GENRE="80er"
COMMENT="ANTENNE BAYERN 80er Kulthits"
# all values in seconds:
TRIM_BEGIN=5
TRIM_END=7
FADE_IN=2
FADE_OUT=5
fadecut-0.1.4/examples/chillout 0000664 0000000 0000000 00000001570 12406256740 0016524 0 ustar 00root root 0000000 0000000 # This file is part of fadecut
# https://github.com/micressor/fadecut
#
# fadecut is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fadecut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with fadecut. If not, see .
STREAM_URL="http://mp3channels.webradio.antenne.de/chillout"
GENRE="Chillout"
COMMENT="ANTENNE BAYERN Chillout"
# all values in seconds:
TRIM_BEGIN=5
TRIM_END=7
FADE_IN=2
FADE_OUT=5
fadecut-0.1.4/examples/swisspop 0000664 0000000 0000000 00000001553 12406256740 0016571 0 ustar 00root root 0000000 0000000 # This file is part of fadecut
# https://github.com/micressor/fadecut
#
# fadecut is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fadecut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with fadecut. If not, see .
STREAM_URL="http://livestream.srg-ssr.ch/1/rsp/mp3_128"
GENRE="SwissPop"
COMMENT="Radio Swiss Pop"
# all values in seconds:
TRIM_BEGIN=0
TRIM_END=0
FADE_IN=1
FADE_OUT=4
fadecut-0.1.4/fadecut 0000775 0000000 0000000 00000053007 12406256740 0014503 0 ustar 00root root 0000000 0000000 #!/bin/bash
#
# This file is part of fadecut
# https://github.com/micressor/fadecut
#
# fadecut is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fadecut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with fadecut. If not, see .
# Script exit codes ------------------------------------------------------------
# Returnvalues : 0 - successfully
# 1 - partionally unsuccuessfully
# 2 - function unexpected aborted
# 3 - action aborted
# 4 - syntax error
# 5 - couldn't read, write or find file
# 6 - invalid status
# 99 - undefinded error code
#
# Constants --------------------------------------------------------------------
#
# you may overwrite all this constants in
# ~/.fadecut/fadecutrc
# and/or
# ~/.fadecut/profiles/
#
FILES=*.mp3 # which files to work on
ENCODING=ogg # target format [ogg/mp3]
TRIM_BEGIN=0 # trim n seconds at beginning
TRIM_END=0 # trim n seconds at end of song
FADE_IN=1 # seconds to fade in
FADE_OUT=4 # seconds to fade out
PWD=$(pwd) # main directory of fadecut
LOGDIR=/tmp # where to write logfiles
PROFILEDIR="$HOME/.fadecut" # profiledir
WORKDIR="$PWD" # workdir
OUTPUTDIR="$PWD/new" # where to put fadecut'ted files
ORIGDIR="$PWD/orig" # where to put original files
DONEDIR="$PWD/done" # here the user puts finished
# files, which are tested and
# listened
DONTLIKEDIR="$PWD/dontlike" # here are songs we don't like
ERRORDIR="$PWD/error" # files had an error
TMPDIR=/tmp # here to put temporary files
ENQUEUE=0 # enqueue to rhythmbox or vlc
KEEPORIG=0 # don't keep original files
DEBUG=0 # debug level 0-3
VERBOSE=0 # verbosity level
LOOP_INTERVAL=10 # loop interval in seconds
RESTART_STREAMRIPPER_INTERVAL=900 # restart interval streamripper
STREAMRIPPER_START=0 # start streamripper [0/1]
USER_AGENT="Streamripper/1.x" # streamripper useragent
STREAMRIPPER_OPTS="-o always -T" # streamripper options
E_NOARGS=65 # standard errorlevel definition
PID=$$ # fadecut's pid
# define all binaries
BIN_STREAMRIPPER=$(which streamripper)
BIN_SOX=$(which sox)
BIN_OGGINFO=$(which ogginfo)
BIN_OGGENC=$(which oggenc)
BIN_ID3V2=$(which id3v2)
BIN_LAME=$(which lame)
# Variables --------------------------------------------------------------------
PidStreamripper="-1"
IdleCounter=-1
IdleSeconds=0
MissingVar=""
Fdst=""
PostExit=0 # Used for delayed shutdown's
Editor=vi
if [ -n "$EDITOR" ]; then
Editor="$EDITOR"
fi
# Functions --------------------------------------------------------------------
usage()
#
# Description: shows help text
#
# Parameter : none
#
# Output : shows help text
#
{
cat << EOF
usage: $0 -p [other options]
OPTIONS:
-p Profile
-r Stream (and rip), start streamripper
-c create profile
-e edit profile
-i optional input directory
-o optional output directory
-k keep original file
-d Debug: -d 0|1|2|3 (level 0 is standard, -d without number is like 1)
-h Show this message
-q Quiet
-v Verbose
EOF
return 0
}
logging()
#
# Description: It writes messages to logfile or standard output.
#
# Parameter : $1 - the level of message
# $2 - the message
#
# Std. Output: Logging messages.
#
{
if [ $DEBUG -ge 3 ]; then set -x
fi
logtime="$(date +%H):$(date +%M):$(date +%S)"
prefix=""
stderr=-1
case $1 in
-e) prefix="Error: " stderr=1 verbose=0;;
-i) prefix="Info: " stderr=0 verbose=0;;
-n) prefix="Notice: " stderr=0 verbose=1;;
-s) prefix="Success: " stderr=0 verbose=0;;
-w) prefix="Warning: " stderr=1 verbose=1;;
-d) prefix="Debug: " stderr=1 verbose=2;;
-a) prefix=" " stderr=1 verbose=0;;
-r) prefix="Stream: " stderr=0 verbose=0;;
esac
shift
# marco: We need to document this better!
# tinu: good enough now? :-)
# if VERBOSE mode is set, then show all messages, which we want to show in verbose mode
if [ $verbose -ge 1 ] && [ $VERBOSE -ge 1 ] ; then
if [ "$stderr" -eq 1 ]; then
echo "$logtime $prefix" $1 >&2
else
echo "$logtime $prefix" $1
fi
# else show only messages which are defined to show in non-verbose mode
elif [ $verbose -eq 0 ] ; then
if [ "$stderr" -eq 1 ]; then
echo "$logtime $prefix" $1 >&2
else
echo "$logtime $prefix" $1
fi
fi
}
createDirs()
#
# Description: creates needed directories
#
# Parameter : none
#
# Output : none
#
{
if [ $DEBUG -ge 3 ]; then set -x
fi
if [ ! -d "$PROFILEDIR/profiles" ]; then
mkdir -p "$PROFILEDIR/profiles"
fi
return 0
}
startStream()
#
# Description: forks the streamripper process
#
# Parameter : none
#
# Output : none
#
{
if [ $DEBUG -ge 3 ]; then set -x
fi
cd "$WORKDIR"
if [ ! -x $BIN_STREAMRIPPER ]; then
logging -e "Ooops! Streamripper not found"
shutdown_fadecut 3
fi
if [ ! -d "/proc/$PidStreamripper" ] && [ "$STREAMRIPPER_START" == "1" ];
then
$BIN_STREAMRIPPER $STREAM_URL -d . \
--codeset-filesys=utf8 \
--codeset-id3=ISO-8859-1 \
-u $USER_AGENT \
-s $STREAMRIPPER_OPTS \
> $LOGDIR/fadecutstream-$PID.log 2>&1 &
PidStreamripper=$!
logging -s "$BIN_STREAMRIPPER started pid=$PidStreamripper"
else
logging -n "$BIN_STREAMRIPPER running pid=$PidStreamripper"
fi
cd "$PWD"
return 0
}
shutdown_streamripper()
#
# Description: shutting down streamripper
#
# Parameter : none
#
# Output : logging
#
{
if [ $DEBUG -ge 1 ]; then set -x
fi
TmpPid=$(pidof streamripper)
if [ -z "$TmpPid" ]; then return 0
fi
if [[ " $TmpPid " == *" $PidStreamripper "* ]];
then
logging -i "Shuting down streamripper"
kill $PidStreamripper
sleep 1
if [[ " $(pidof streamripper) " == *" $PidStreamripper "* ]];
then
logging -w "Streamripper still here, killing it!"
kill -9 $PidStreamripper
fi
else
logging -n "Another streamripper is still running"
fi
return 0
}
shutdown_fadecut()
#
# Description: shutting down fadecut and cleaning up
#
# Parameter : none
#
# Output : logging
#
{
if [ $DEBUG -ge 1 ]; then set -x
fi
logging -n "Shutting down fadecut..."
ExitCode=$1
shutdown_streamripper
showStats
if [ -f "$LOGDIR/fadecutstream-$PID.log" ] ; then
rm $LOGDIR/fadecutstream-$PID.log
fi
case $ExitCode in
0)
logging -s "Fadecut stopped!"
;;
1)
logging -w "Fadecut stopped partionally unsuccuessfull"
;;
esac
logging -a "Returnvalue=$ExitCode"
exit $ExitCode
}
queueSong()
#
# Description: queue song to music player
#
# Parameter : none
#
# Output : logging
#
{
if [ $DEBUG -ge 2 ]; then set -x
fi
if [ $ENQUEUE -eq "1" ]; then
if [ "$(pidof rhythmbox)" ];
then
logging -i "Rhythmbox is running, adding to playlist"
rhythmbox-client --enqueue "$OUTPUTDIR"/"$Fdst"
fi
if [ "$(pidof vlc)" ];
then
# enqueue to vlc player if in one instance mode (default disabled)
logging -i "vlc is running, adding to playlist"
vlc --playlist-enqueue "$OUTPUTDIR"/"$Fdst" > /dev/null 2>&1
fi
fi
return 0
}
control_c()
#
# Description: run if user hits control-c
#
# Parameter : none
#
# Output : logging
#
{
if [ $DEBUG -ge 3 ]; then set -x
fi
logging -n "CTRL-C catched"
shutdown_fadecut 0
}
loop_fadecut()
#
# Description: main processing function of fadecut
#
# Parameter : none
#
# Output : none
#
{
if [ $DEBUG -ge 3 ]; then set -x
fi
RetLoop=0
cd "$WORKDIR"
for F in $FILES
do
# if there are no more files to process, go to idle state or clean up
# and shutdown fadecut.
if [ "$F" == "$FILES" ]; then
let IdleCounter=$((IdleCounter+1))
let IdleSeconds=$((IdleCounter*LOOP_INTERVAL))
logging -n "no files to process, idle for $IdleSeconds seconds"
if [ $STREAMRIPPER_START == "0" ];
then
shutdown_fadecut ${PostExit}
else
if [ $IdleSeconds -ge $RESTART_STREAMRIPPER_INTERVAL ];
then
logging -w "Oops! Seems to hang, restarting it"
shutdown_streamripper
startStream
IdleCounter=0
fi
fi
break
fi
IdleCounter=0
# Checking part of loop_fadecut()
# check next file
logging -i "Processing:"
logging -a "$F"
Fstatus="processing"
Fnew=$(filerename $F)
# Converting id3v1->id3v2 tags, if necessary. Must be before `id3v2 -l`
# command.
id3v2 -C "$F" > /dev/null 2>&1
ARTIST=`id3v2 -l "$F" | sed -e '/TPE1/!d' -e 's/^.*: //g'`
TITLE=`id3v2 -l "$F" | sed -e '/TIT2/!d' -e 's/^.*: //g'`
# do some checks, check if file already exists and set status
# status will be written to statslog
# depending on status the processing will continue or will skipped to next file
if [[ -z $ARTIST ]] || [[ -z $TITLE ]]
then
logging -e "could not get mp3 tags from source file."
logging -e "ARTIST: $ARTIST / TITLE: $TITLE"
move_file "$F" "$ERRORDIR"
Fstatus="error-notags"
PostExit=1
elif [ -f "$DONEDIR"/"$F" ] || [ -f "$DONEDIR"/"$Fnew" ] ; then
logging -i "File already exists in $DONEDIR ..."
rm "$F"
Fstatus="double-done"
elif [ -f "$OUTPUTDIR"/"$F" ] || [ -f "$OUTPUTDIR"/"$Fnew" ] ; then
logging -i "File already exists in $OUTPUTDIR ..."
rm "$F"
Fstatus="double-output"
elif [ -f "$DONTLIKEDIR"/"$F" ] || [ -f "$DONTLIKEDIR"/"$Fnew" ] ; then
logging -i "I don't like. File exists in $DONTLIKEDIR -> deleting ..."
rm "$F"
Fstatus="dontlike"
fi
writeStats "$ARTIST" "$TITLE" "$GENRE" "$PROFILE" "$Fstatus" "$Fnew"
# skip processing of current file if it is "double" or "don't like"
if [[ $Fstatus != "processing" ]] ; then
continue
fi
# Processing part of loop_fadecut()
if [ "$KEEPORIG" -eq "1" ]; then
copy_file "$F" "$ORIGDIR"
fi
splitting "$F" "$ARTIST" "$TITLE" "$GENRE" "$COMMENT"
LENGTH=`sox "$TMPDIR"/"$F" -n stat 2>&1 | grep Length | sed -e 's/.* //' -e 's/\..*//'`
let TRIMLENGTH=$((LENGTH-TRIM_BEGIN-TRIM_END))
let FADE_OUT_START=$((TRIMLENGTH-FADE_OUT))
if [ "$ENCODING" == "mp3" ]; then
mp3Encoding "$F"
fi
if [ "$ENCODING" == "ogg" ]; then
oggEncoding "$F"
fi
if [ "$RetLoop" -eq "0" ]; then
logging -s "Ready for listening:"
logging -a "$Fdst"
rm "$TMPDIR"/"$F"
rm "$F"
else
move_file "$F" "$ERRORDIR"
# when sox or lame are receiving SIGINT they exit with return-code > 0
# the ctrl_c function does not catch this case, so we have to break here
logging -n "loop_fadecut(): Oops! Something was wrong."
logging -e "loop_fadecut(): returnvalue=$RetLoop"
shutdown_fadecut 3
fi
queueSong
showStats
done
cd "$PWD"
}
load_profile()
#
# Description: loading fadecutrc and profile file
#
# Parameter : none
#
# Output : none
#
{
if [ $DEBUG -ge 2 ]; then set -x
fi
createDirs
logging -i "Loading profile file(s):"
if [ -r "$PROFILEDIR/fadecutrc" ]; then
logging -a "$PROFILEDIR/fadecutrc"
. "$PROFILEDIR/fadecutrc"
fi
if [ ! -r "$PROFILEDIR/profiles/$PROFILE" ]; then
logging -e "Can't not load profile $PROFILEDIR/profiles/$PROFILE"
exit 1
fi
logging -a "$PROFILEDIR/profiles/$PROFILE"
. "$PROFILEDIR/profiles/$PROFILE"
check_profile
}
create_profile()
#
# Description: creates a new profile
#
# Parameter : none
#
# Output : none
#
{
if [ $DEBUG -ge 2 ]; then set -x
fi
createDirs
NEW=$1
echo \
"STREAM_URL=\"http://radiostream\"
GENRE=\"YourGenre\"
COMMENT=\"Your Comment\"
# all values in seconds:
FADE_IN=1
FADE_OUT=4
# TRIM_BEGIN=0
# TRIM_END=0" > "$PROFILEDIR/profiles/$NEW"
logging -i "Starting $Editor editor"
$Editor "$PROFILEDIR/profiles/$NEW"
logging -i "Now start: fadecut -p $NEW [optional other options]"
}
edit_profile()
#
# Description: edit an existing profile
#
# Parameter : $1 profile name
#
# Output : none
#
{
$Editor "$PROFILEDIR/profiles/$1"
}
check_profile()
#
# Description: check existing profile
# we need all variables to work
#
# Parameter : none
#
# Output : none
#
{
if [ $DEBUG -ge 2 ]; then set -x
fi
RetCheckProfile=0
MissingVar=""
if [ -z "$STREAM_URL" ]; then
RetCheckProfile=1
MissingVar="STREAM_URL"
fi
if [ -z "$COMMENT" ]; then
RetCheckProfile=1
MissingVar="COMMENT $MissingVar"
fi
if [ -z "$TRIM_BEGIN" ]; then
RetCheckProfile=1
MissingVar="TRIM_BEGIN $MissingVar"
fi
if [ -z "$TRIM_END" ]; then
RetCheckProfile=1
MissingVar="TRIM_END $MissingVar"
fi
if [ -z "$FADE_IN" ]; then
RetCheckProfile=1
MissingVar="FADE_IN $MissingVar"
fi
if [ -z "$FADE_OUT" ]; then
RetCheckProfile=1
MissingVar="FADE_OUT $MissingVar"
fi
if [ $RetCheckProfile -eq 1 ];
then
logging -e "$PROFILEDIR/profiles/$PROFILE:"
logging -a "$MissingVar not defined"
shutdown_fadecut 1
fi
return 0
}
showStats()
#
# Description: shows file statistics
#
# Parameter : none
#
# Output : none
#
{
if [ $DEBUG -ge 3 ]; then set -x
fi
# show statistics only, if all directories are existing
if [ -d "$OUTPUTDIR" ]; then
StatsNewDir=`ls -1 "$OUTPUTDIR" | wc -l`
fi
if [ -d "$ORIGDIR" ]; then
StatsOrigDir=`ls -1 "$ORIGDIR" | wc -l`
fi
if [ -d "$DONEDIR" ]; then
StatsDoneDir=`ls -1 "$DONEDIR" | wc -l`
fi
if [ -d "$DONTLIKEDIR" ]; then
StatsDontlikeDir=`ls -1 "$DONTLIKEDIR" | wc -l`
fi
if [ -d "$ERRORDIR" ]; then
StatsErrorDir=`ls -1 "$ERRORDIR" | wc -l`
fi
logging -i "showStats:"
logging -a "Output:$StatsNewDir Orig:$StatsOrigDir Done:$StatsDoneDir Dontlike:$StatsDontlikeDir Error:$StatsErrorDir"
if [ -f "$PROFILEDIR"/statslog.csv ]; then
double=$(grep ";double-" "$PROFILEDIR"/statslog.csv | \
grep ";$PROFILE;" | \
cut -d \; -f 4 | \
sort -u | \
wc -l)
processed=$(grep ";processing" "$PROFILEDIR"/statslog.csv | \
grep ";$PROFILE;" | \
cut -d \; -f 4 | \
sort -u | \
wc -l)
logging -a "Double:$double Processed:$processed"
fi
}
writeStats()
#
# Description: writes statistics log
#
# Parameter : $1 "artist"
# $2 "title"
# $3 "genre"
# $4 "profile"
# $5 "status"
# $6 "filename"
#
# Usage : writeStats "artist" "title" "genre" "profile" "status" "filename"
#
# Output : none
#
{
if [ $DEBUG -ge 1 ]; then set -x
fi
date=`date +%d.%m.%Y`
time=`date +%H:%M:%S`
artist=`echo "$1" | iconv -f ISO-8859-1 -t UTF-8`
title=`echo "$2" | iconv -f ISO-8859-1 -t UTF-8`
genre="$3"
profile="$4"
status="$5"
filename="$6"
echo "$date;$time;$artist;$title;$genre;$profile;$status;$filename" >> "$PROFILEDIR"/statslog.csv
}
oggEncoding()
#
# Description: encoding to ogg
#
# Parameter : $1 filename
#
# Output : none
#
{
if [ $DEBUG -ge 1 ]; then set -x
fi
Fsrc="$*"
Fdst=$(filerename $Fsrc)
if [ ! -d "$OUTPUTDIR" ]; then
mkdir -p "$OUTPUTDIR"
fi
# The Bash ‘-o pipefail’ option to set will cause a pipeline to return a
# failure status if any command fails.
set -o pipefail
nice -15 sox -V1 "$TMPDIR"/"$F" -t wav - trim $TRIM_BEGIN $TRIMLENGTH \
silence -l 1 0.5 0.1% -1 0.5 0.1% \
fade t $FADE_IN $FADE_OUT_START $FADE_OUT | \
oggenc - --quiet -t "$TITLE" -a "$ARTIST" -G "$GENRE" \
-c "comment=$COMMENT" -o "$OUTPUTDIR"/"$Fdst" || RetLoop=3
# Disable pipefail (default)
set +o pipefail
if [ $VERBOSE -ge 1 ];
then
ogginfo "$OUTPUTDIR"/"$Fdst" || RetLoop=3
fi
}
mp3Encoding()
#
# Description: encoding to mp3
#
# Parameter : $1 filename
#
# Output : none
#
{
if [ $DEBUG -ge 1 ]; then set -x
fi
Fsrc="$*"
Fdst=$(filerename $Fsrc)
if [ ! -d "$OUTPUTDIR" ]; then
mkdir -p "$OUTPUTDIR"
fi
# The Bash ‘-o pipefail’ option to set will cause a pipeline to return a
# failure status if any command fails.
set -o pipefail
nice -15 sox -V1 "$TMPDIR"/"$Fsrc" -t wav - trim $TRIM_BEGIN $TRIMLENGTH \
silence -l 1 0.5 0.1% -1 0.5 0.1% \
fade t $FADE_IN $FADE_OUT_START $FADE_OUT | \
lame --quiet --add-id3v2 --ta "$ARTIST" --tt "$TITLE" \
--tg "$GENRE" --tc "$COMMENT" - "$OUTPUTDIR"/"$Fdst" || RetLoop=3
# Disable pipefail (default)
set +o pipefail
# delete tag written by lame (TLEN is always the same and always wrong)
# found with LAME 32bits version 3.98.4
# this patch was made after a feedback of Jonas Schmid
id3v2 --TLEN "" "$OUTPUTDIR"/"$Fdst"
}
splitting()
#
# Description: split files using silence detection of sox
#
# Parameter : $1 filename
# $2 "artist"
# $3 "title"
# $4 "genre"
# $5 "comment"
#
# Output : none
#
{
F="$1"
ARTIST="$2"
TITLE="$3"
GENRE="$4"
COMMENT="$5"
sox -V1 "$F" -t wav "$TMPDIR"/"$F".wav silence 1 0.50 0.1% 1 0.5 0.1% : newfile : restart
Fcount=`ls -1 "$TMPDIR"/"$F"* | wc -l`
#choose biggest file of sox output as we think this will be the wanted main part
Ftmp=`ls -1S "$TMPDIR"/"$F"* | sed -e 's/.*\///g' | head -1`
mv "$TMPDIR"/"$Ftmp" "$TMPDIR"/"$F"
if [ $Fcount -ge 2 ] ; then
logging -i "sox found silence and splitted..."
rm "$TMPDIR"/"$F"00*
Fnew=$(filerename $F)
writeStats "$ARTIST" "$TITLE" "$GENRE" "$PROFILE" "soxsplit into $Fcount files" "$Fnew"
fi
return 0
}
filerename()
#
# Description: rename filenames
#
# Parameter : $1 old filename
#
# Output : new filename
#
{
if [ $DEBUG -ge 2 ]; then set -x
fi
Fnold="$*"
# Change destination filename according to selected $ENCODING
local tmp=$(echo $Fnold | sed -e "s/\.mp3/\.$ENCODING/g")
Fnnew=$(echo $tmp | sed -e 's/ /_/g' -e 's/\(.*\)/\L\1/')
echo $Fnnew
return 0
}
checkRequirements()
#
# Description: Check if all necessary tools and binaries are available
#
# Parameter : none
#
# Output : logging
# forces an error if a needed binary is not available
#
{
if [ $DEBUG -ge 3 ]; then set -x
fi
logging -d "Checking fadecut requirements"
if [ -z $BIN_STREAMRIPPER ]; then RequirementsMsg=streamripper
fi
if [ -z $BIN_SOX ]; then RequirementsMsg=sox
fi
if [ -z $BIN_ID3V2 ]; then RequirementsMsg=id3v2
fi
if [ "$ENCODING" == "ogg" ];
then
if [ -z $BIN_OGGINFO ]; then RequirementsMsg=ogginfo
fi
if [ -z $BIN_OGGENC ]; then RequirementsMsg=oggenc
fi
fi
if [ "$ENCODING" == "mp3" ];
then
if [ -z $BIN_LAME ]; then RequirementsMsg=lame
fi
fi
if [ ! -z $RequirementsMsg ];
then
logging -e "Program $RequirementsMsg not installed or not in PATH"
return 1
fi
if [ ! -w "$WORKDIR" ];
then
logging -e "Cannot write into $WORKDIR directory"
return 1
fi
return 0
}
copy_file()
#
# Description: checks if directory exists, creates it if necessary and copy file to it
#
# Parameter : $1 file
# $2 destination directory
#
# Output : none
#
{
if [ $DEBUG -ge 1 ]; then set -x
fi
if [ ! -d "$2" ]; then
mkdir -p "$2"
fi
cp "$1" "$2"
return 0
}
move_file()
#
# Description: checks if directory exists, creates it if necessary and moves file to it
#
# Parameter : $1 file
# $2 destination directory
#
# Output : none
#
{
if [ $DEBUG -ge 1 ]; then set -x
fi
if [ ! -d "$2" ]; then
mkdir -p "$2"
fi
mv "$1" "$2"
return 0
}
# Main ------------------------------------------------------------------------
# trap keyboard interrupt (control-c)
trap control_c SIGINT
# When you need an argument that needs a value, you put the ":" right after
# the argument in the optstring. If your var is just a flag, withou any
# additional argument, just leave the var, without the ":" following it.
#
# please keep letters in alphabetic order
#
while getopts ":c:d:e:hi:ko:p:qrv" OPTION
do
case $OPTION in
c)
create_profile $OPTARG
exit 0
;;
d)
DEBUG=$OPTARG
;;
e)
edit_profile $OPTARG
exit 0
;;
h)
usage
exit 1
;;
i)
WORKDIR=$OPTARG
if [ ! -d "$WORKDIR" ];
then
logging -e "$WORKDIR: Input directory does not exist"
shutdown_fadecut 3
fi
logging -n "Using for input: $WORKDIR"
;;
k)
KEEPORIG=1 # keep original files
;;
o)
OUTPUTDIR=$OPTARG
if [ ! -d "$OUTPUTDIR" ];
then
logging -e "$OUTPUTDIR: Output directory does not exist"
shutdown_fadecut 3
fi
logging -n "Using for output: $OUTPUTDIR"
;;
p)
PROFILE=$OPTARG
load_profile
if ! checkRequirements; then shutdown_fadecut 1
fi
;;
q)
DEBUG=0
VERBOSE=0
# add LOGGING variable and change logging function to be able to turn
# all output off
;;
r)
STREAMRIPPER_START=1
;;
v)
VERBOSE=1
;;
\?)
logging -e "Invalid option: -$OPTARG" >&2
usage
shutdown_fadecut 1
;;
:)
logging -e "Option -$OPTARG requires an argument." >&2
shutdown_fadecut 1
;;
esac
done
if [ -z $PROFILE ] ; then
usage
exit 1
fi
if [ "$OUTPUTDIR" = "$WORKDIR" ];
then
logging -e "Output and input directory can not be equal!"
usage
exit 1
fi
StreamInfo=""
StreamInfo2=""
while true
do
startStream
loop_fadecut
logging -n "Main(): Loop until we're finished"
sleep 2
# if streamripper is working then show info about it
if [ $STREAMRIPPER_START == "1" ] && [ -f $LOGDIR/fadecutstream-$PID.log ];
then
StreamInfo=$(tail -1 $LOGDIR/fadecutstream-$PID.log | sed -e 's/
/\n/g' | tail -1 | sed -e 's/ \[.*$//g')
if [ "$StreamInfo" != "$StreamInfo2" ] ; then
logging -r "$StreamInfo"
StreamInfo2="$StreamInfo"
fi
fi
sleep $LOOP_INTERVAL
done
fadecut-0.1.4/fadecut.1 0000664 0000000 0000000 00000007602 12406256740 0014637 0 ustar 00root root 0000000 0000000 .\"
.\" File Name macro. This used to be `.PN', for Path Name,
.\" but Sun doesn't seem to like that very much.
.\"
.de FN
\fI\|\\$1\|\fP
..
.TH "fadecut" "1" "0.1.0"
.SH NAME
fadecut \- Toolset to rip audiostreams, cut, fade in/out and tag the resulting audiofiles
.SH SYNOPSIS
fadecut \-p [
.I OPTIONS
]
.SH DESCRIPTION
fadecut is a script to rip audio files from a livestream (using streamripper) and
to process them automatically. Beginning and ending fo the audio files will be
cut and faded in/out. So logos and advertising of radio stations will be
automatically removed.
.PP
In streaming mode fadecut is ripping audio files using streamripper. The
downloaded audio files are cutted using silence detection and then faded in and
out. Subsequently, the files are encoded to either ogg or mp3 and tagged with
tags (title, artist, genre and comment provided).
.PP
In file mode fadecut is just processing already ripped audio files.
.PP
An audio file which has already been processed is detected and will not be
processed again. Not desired songs can be stored in a separate directory. This
files are not processed anymore too.
.SH FOLDERS
fadecut is working with some standard folders. You may change them in your
profile or fadecutrc
.PP
.B done/
here you put all your songs which were already processed by fadecut and which
you want to keep. See also new/ folder.
.PP
.B dontlike/
in this folder you may put songs which you don't like. Fadecut is checking this
folder before it is processing new files in the working folder. Null size files
are ok.
.PP
.B error/
whenever an error occurs while fadecut is processing a file, that file is moved
to the error folder for later examining.
.PP
.B incomplete/
this folder is created by streamripper. All not fully ripped songs are saved
here.
.PP
.B new/
processed songs are going here. Usually you may rip and process files with
fadecut, they are going in to new/ folder, you listen to them and put good songs
to the done/ folder.
.PP
.B orig/
if you want to keep the original file (which is ripped by streamripper), you may
use the \-k option. fadecut is putting the ripped files untouched into that
folder.
.PP
.SH OPTIONS
.B \-c
Create a new profile
.PP
.B \-e
Edit an existing profile
.PP
.B \-i
optional input
.PP
.B \-o
optional output
.PP
.B \-k
optional to keep the untouched original song in the /orig folder
.PP
.B \-d
Debug: \-d 0|1|2|3 (level 0 is standard, \-d without number is like 1)
.PP
.B \-h
Show this message
.PP
.B \-p
Profile
.PP
.B \-q
Quiet
.PP
.B \-r
Stream (and rip), start streamripper
.PP
.B \-v
Verbose
.SH VARIABLES
STREAM_URL="http://streamurl"
.RS
test
.RE
.PP
ENCODING=ogg
.RS
preferred destination fileformat. (ogg/mp3)
.RE
.PP
GENRE="SwissPop"
.RS
Processed files will get the above genre.
.RE
.PP
COMMENT="Radio Swiss Pop"
.RS
Processed files will get the above comment.
.RE
.PP
TRIM_BEGIN=0
.RS
cut seconds off the file in the beginning.
.RE
.PP
TRIM_END=0
.RS
cut seconds off the file at the end.
.RE
.PP
FADE_IN=1
.RS
Fade in for seconds.
.RE
.PP
FADE_OUT=4
.RS
Fade out for seconds.
.RE
.PP
USER_AGENT="Streamripper/1.x"
.RS
Set the user-agent used by streamripper
.RE
.SH EXAMPLES
Create a new ripping profile
.RS
fadecut \-c test
.RE
.PP
Edit/update profile test
.RS
fadecut \-e test
.RE
.PP
Rip, cut and fade in\-/out with profile test
.RS
fadecut \-p test \-r
.RE
.PP
Only cut and fade in\-/out without ripping from livestream
.RS
fadecut \-p test
.RE
.PP
.SH SEE ALSO
\fBid3v2\fR(1), \fBoggenc\fR(1), \fBsox\fR(1), \fBstreamripper\fR(1),
\fBlame\fR(1)
.PP
.SH FILES
.PD 0
.TP
.FN ~/.fadecut/fadecutrc
The main fadecut configuration file, executed with every start of fadecut
.TP
.FN ~/.fadecut/statslog.csv
The statistics file
.TP
.FN ~/.fadecut/profiles
The folder where all profiles are located
.PD
.SH RESOURCES
.TP
fadecut git website
https://github.com/micressor/fadecut
fadecut-0.1.4/fcstats 0000775 0000000 0000000 00000001550 12406256740 0014533 0 ustar 00root root 0000000 0000000 #!/bin/bash
# Marc-Alain, 28.02.2011
# Sortierung ist gerade aufgrund vom „< Artist >–< Titel >“
# (Befehl: $tmp="$F[2]-$F[3]"). Gesamte Daten werden denn im %d Hash Array
# gespeichert, wo jeder Element einen Array mit allen Daten der Zeile
# (Befehl: $d{ $tmp } = [ map{ s/\s+$//; $_ } @F ]) beinhaltet (im Perl,
# Option „-a“ heisst: speichert jeder Element der Zeile im @F Array. Die
# Option „-F\;“ heisst jeder Element der Zeile ist mit dem gesetzten
# Buchstaben getrennt)… Für den Rest… mal zusammen diskutieren…
perl -F\; -alne '$tmp="$F[2]-$F[3]";$d{ $tmp } = [ map{ s/\s+$//; $_ } @F ]; $times{ $tmp }++; map{ $max[$_]=$max[$_] > length $F[$_] ? $max[$_] : length $F[$_] }0..$#F; next unless eof(); $pf=join"|", map{ " %-${_}s " }@max; map{ printf "|$pf| %3d |\n", @{ $d{ $_ } }, $times{ $_ } } sort keys %d' ~/.fadecut/statslog.csv
fadecut-0.1.4/testing/ 0000775 0000000 0000000 00000000000 12406256740 0014612 5 ustar 00root root 0000000 0000000 fadecut-0.1.4/testing/cleanup.sh 0000775 0000000 0000000 00000002261 12406256740 0016601 0 ustar 00root root 0000000 0000000 #!/bin/bash
#
# This file is part of fadecut
# https://github.com/micressor/fadecut
#
# fadecut is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fadecut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with fadecut. If not, see .
# --- Constants ----------------------------------------------------------------
. ./config || exit 3
# --- Variables ----------------------------------------------------------------
# --- Main ---------------------------------------------------------------------
retMain=0
if [ -d "${HOME_FADECUT}" ] && \
[ -r "/tmp/fadecut_${LOGNAME}.tgz" ];
then
rm -rf ${HOME_FADECUT}
cd /
echo "Restoring home"
tar xf /tmp/fadecut_${LOGNAME}.tar || retMain=3
fi
rm ${LOCKFILE}
exit $retMain
fadecut-0.1.4/testing/config 0000664 0000000 0000000 00000000322 12406256740 0015777 0 ustar 00root root 0000000 0000000 export PWD=`pwd`
export LOCKFILE=/tmp/fadecuttesting.lk
export HOME_FADECUT=${HOME}/.fadecut
export BIN_FADECUT="../../fadecut"
export RECIPES="${PWD}/recipes"
export TESTFOLDER="$(readlink -f $(dirname $0))"
fadecut-0.1.4/testing/fctest 0000775 0000000 0000000 00000002712 12406256740 0016032 0 ustar 00root root 0000000 0000000 #!/bin/bash
#
# This file is part of fadecut
# https://github.com/micressor/fadecut
#
# fadecut is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fadecut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with fadecut. If not, see .
# --- Constants ---------------------------------------------------------------
. ./config || exit 1
# --- Main --------------------------------------------------------------------
retMain=0
set -o pipefail
if [ -e ${LOCKFILE} ];
then
echo "${LOCKFILE}: exists already"
exit 1
fi
./prepare.sh
if [ $? -ge 1 ]; then
echo "error while preparing test environment"
exit 1
fi
mkdir ${HOME_FADECUT}
# loop ./recipts/*
cd ${RECIPES}
for Recipe in *.sh
do
echo ./$Recipe $TESTFOLDER
./$Recipe $TESTFOLDER
if [ $? -ge 1 ];
then
echo "$Recipe: Failed!"
retMain=1
else
echo "$Recipe: Sucess!"
fi
done
cd -
./cleanup.sh
if [ $? -ge 1 ]; then
echo "error while cleaning up test environment"
exit 1
fi
echo "returnvaule=${retMain}"
exit ${retMain}
fadecut-0.1.4/testing/prepare.sh 0000775 0000000 0000000 00000002574 12406256740 0016617 0 ustar 00root root 0000000 0000000 #!/bin/bash
#
# This file is part of fadecut
# https://github.com/micressor/fadecut
#
# fadecut is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fadecut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with fadecut. If not, see .
# --- Constants ----------------------------------------------------------------
. ./config || exit 3
# --- Variables ----------------------------------------------------------------
# --- Main ---------------------------------------------------------------------
retMain=0
touch ${LOCKFILE} || exit 3
if [ -d "${HOME_FADECUT}" ];
then # if there is already an existing
# fadecut homedir, then safe it
if tar cf /tmp/fadecut_${LOGNAME}.tar ${HOME_FADECUT};
then
rm -rf ${HOME_FADECUT}
echo "Home backed up and removed"
retMain=0
else
retMain=3
fi
else
#retMain=3
echo "no fadecut homedir, nothing to safe"
fi
exit $retMain
fadecut-0.1.4/testing/recipes/ 0000775 0000000 0000000 00000000000 12406256740 0016244 5 ustar 00root root 0000000 0000000 fadecut-0.1.4/testing/recipes/fileprocessing.sh 0000775 0000000 0000000 00000002726 12406256740 0021626 0 ustar 00root root 0000000 0000000 #!/bin/bash
#
# This file is part of fadecut
# https://github.com/micressor/fadecut
#
# fadecut is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fadecut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with fadecut. If not, see .
main()
{
pushd .
TestFolder="$1"
cd "$TestFolder"/testdir
cp "$TestFolder"/testfiles/test_source/*.mp3 .
mkdir -p "$HOME_FADECUT"/profiles/
echo \
"STREAM_URL=\"http://fctest_fileproc_mp3\"
GENRE=\"fadecut testgenre\"
COMMENT=\"fadecut test fileprocessing mp3\"
# all values in seconds:
FADE_IN=1
FADE_OUT=4
TRIM_BEGIN=0
TRIM_END=0" > "$HOME_FADECUT"/profiles/fctest_fileproc_mp3
# start test
$BIN_FADECUT -p fctest_fileproc_mp3
Ret=$?
# eval test results
# Because we process files with no id tags, fadecut will return with exitcode 1
# and that is that what we expect in this variation.
if [ $Ret -eq 1 ]; then return 0 # if all ok, return with errorlevel 0
fi
# ... todo ...
# cleanup
rm -rf error new orig
popd
return 1
}
main "$1"
if [ $? -ge 1 ]; then
exit 1
else
exit 0
fi
fadecut-0.1.4/testing/recipes/helpmenu.sh 0000775 0000000 0000000 00000001571 12406256740 0020424 0 ustar 00root root 0000000 0000000 #!/bin/bash
#
# This file is part of fadecut
# https://github.com/micressor/fadecut
#
# fadecut is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fadecut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with fadecut. If not, see .
main()
{
#set -x
echo "--> Check display of help menu"
$BIN_FADECUT | grep -q OPTIONS
Ret=$?
if [ $Ret -eq 0 ]; then return 0
fi
#set +x
return 1
}
if ! main; then exit 1
fi
exit 0
fadecut-0.1.4/testing/recipes/recipt.template 0000775 0000000 0000000 00000001513 12406256740 0021272 0 ustar 00root root 0000000 0000000 #!/bin/bash
#
# This file is part of fadecut
# https://github.com/micressor/fadecut
#
# fadecut is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fadecut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with fadecut. If not, see .
main()
{
#set -x
echo "template"
#$BIN_FADECUT -h
#Ret=$?
#If [ $Ret -ne 0 ]; return 1
#fi
#return 0
}
if ! main; then exit 1
fi
exit 0
fadecut-0.1.4/testing/recipes/syntaxchecks.sh 0000775 0000000 0000000 00000001551 12406256740 0021314 0 ustar 00root root 0000000 0000000 #!/bin/bash
#
# This file is part of fadecut
# https://github.com/micressor/fadecut
#
# fadecut is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fadecut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with fadecut. If not, see .
main()
{
#set -x
echo "--> Script syntax checks"
bash -n $BIN_FADECUT
Ret=$?
if [ $Ret -eq 0 ]; then return 0
fi
#set +x
return 1
}
if ! main; then exit 1
fi
exit 0
fadecut-0.1.4/testing/testdir/ 0000775 0000000 0000000 00000000000 12406256740 0016270 5 ustar 00root root 0000000 0000000 fadecut-0.1.4/testing/testdir/README 0000664 0000000 0000000 00000001521 12406256740 0017147 0 ustar 00root root 0000000 0000000 This file is part of fadecut
https://github.com/micressor/fadecut
fadecut is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
fadecut is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with fadecut. If not, see .
--- testdir --------------------------------------------------------------------
in this directory all tests of the testframework are evaluated
it is by default empty (after cleanup)
fadecut-0.1.4/testing/testfiles/ 0000775 0000000 0000000 00000000000 12406256740 0016614 5 ustar 00root root 0000000 0000000 fadecut-0.1.4/testing/testfiles/sourcefiles/ 0000775 0000000 0000000 00000000000 12406256740 0021137 5 ustar 00root root 0000000 0000000 fadecut-0.1.4/testing/testfiles/sourcefiles/FrankieDeath_com_begin.flac 0000664 0000000 0000000 00001352543 12406256740 0026332 0 ustar 00root root 0000000 0000000 fLaC "
@ X
,OJHuL ( reference libFLAC 1.2.1 20070917 Nuv:s<Eچli+h%xKdƈBH* mk^EJPZEqDVJڨgv%+զԆVJ[iՑ& j*Y,Eފ:c+:i*ej(m*ǥ,Mf,WWHN2ou%>&4\(trm*R5Zrׄn#؇y^SLj/vєP0i2qEH5ÙlGI:NQaw/)3KktW[Z/.KV;Ƶ,uIImgG`;);A |^&j.sBuȰ꒿bRct#rѣigyp"B̰Ef- 5+6Q֩R\W]AO:Sqa)wMዩ<ʝ$J5B+婋E9O1ը)ɇH2+uMRC_JӶ[o\va:&vZ蚔kNUdO?ܚn
bdPC%Ml#n'3iW0+qjȂ[,?ʓ81ZPeTy:j962µKRօ,F-.ts>Tx.(p:d(3HފvOn"GX\
,~~fb+!xk.>Ѱ8*4T|m6bJY=7}Y]"edμP%ds
ȉ'@\sP~OX.hTSTCs+L\9ߪ[J. ]?Pu+RDsV(
W\L.ha\]Ѥ^Ĭ8d6ύJ}9Mth n̼_$Y(e$͞$o+\ GR2 \Qmɬtrq}6Z6~H)hT-\X2@Ҳ.v3c&+ܥ"
3Wb$N)gLg@&;s>"\Zg6zW0X{;Zr9'g8I_%ub.6a4LcUZQ֥֒M,.PlJgɊH\X$TCDrJG#$ۋ4` BP%ltX\(n+Ҫh/YBG7V+JuKi=P&> AH .X2'"T*`4\
.M(ʤUoiUh\B-Ȍ-EAz2+j
醇o_a //:3ބ</5a`܃ɫ6UrQ}Ԝ$vGf.c͠
D+(~5JG덭7]gX=$lկ9R>>w`U$2(>V KGmSM'*,_a*ө.¨,;.4u˥^t7hA0^ XBTBO-zz%%iҺj/nNe<)K,V}_@E閤p5<8:yk2Ӵɒlݞ
T/M%8c%Z6kR p6$GlcKIb{:-&BDGu>+ehaUbe3ecye"y.tа9>qMZ۱= d2oc%XdҬ/w9:{IHc~xDJiRеERgiQG>lK